#-*- coding: utf-8 -+-
#!/usr/bin/python

import sys
import math
import shutil, errno
import os
import shlex
import gzip
from pylab import *
from random import *
import subprocess
from numpy.linalg import norm
import difflib


if len(sys.argv)!= 4:
  sys.stderr.write("Usage: python parseSTRINGactions.py <string_actions> <string_aliases> <outfile>")
  sys.exit(-1)

actions = open(sys.argv[1],'r')
aliases = open(sys.argv[2],'r')
outfile = open(sys.argv[3],'w')

#map gene symbols and corresponding alias (ENSPTRP...), key = alias
alias2gene = {}

#alias (ENSPTRP..) for the query gene
gene_alias = ""

#init map with alias to gene info
for line in aliases:
#9606    ENSP00000070846 PKP2_HUMAN      BLAST_UniProt_ID
		line_vec = line.split('\t')
		#since its human (9606)
		#store 9606.ENSP00000000233  instead of ENSP00000000233 
		gene_alias = "9606." + line_vec[1]
		if "Ensembl_HGNC_UniProt_ID_(mapped_data_supplied_by_UniProt)_GN" in line:
			alias2gene[gene_alias] = line_vec[2]

#parse actions file
for aline in actions:
	if aline.find("ENSP") != -1:
		aline_vec = aline.split('\t')
	if alias2gene.has_key(aline_vec[0]) and alias2gene.has_key(aline_vec[1]):
		outfile.write(alias2gene[aline_vec[0]] + "\t" + alias2gene[aline_vec[1]] + "\t" + aline_vec[2] + "\n")

	
outfile.close()
actions.close()
aliases.close()
	
