#-*- coding: utf-8 -+-
#!/usr/bin/python

import sys
import math
import array
import shutil, errno
import os
import subprocess
import shlex
import gzip
from pylab import *
from random import *
from collections import Counter

if len(sys.argv)!= 5:
  sys.stderr.write("Usage: python translateNodeIDs.py <ingraph_node_ids> <path_file> <outfile1> <outfile2>")
  sys.exit(-1)

igraph_file = open(sys.argv[1],'r')
path_file = open(sys.argv[2],'r')
outfile = open(sys.argv[3],'w')
string_list = open(sys.argv[4],'w')

#key = igraph node id, e.g. 315, store corresponding gene symbol
id2gene = {}

#store uniq set of nodes 
string_nodes = []

#read node ids
for nline in igraph_file:
	entries = (nline.strip()).split("\t")
	id2gene[entries[1]] = entries[0]

source = ""
	
#KCNE1
#2154 2121 2156
for pline in path_file:
	if pline.find("#") != -1:
		source = pline.strip().split("#")[0]
		outfile.write(source)
	elif pline.find("#") == -1:
		entries = (pline.strip()).split(" ")
		nodes = filter(None,entries)
		print nodes
		for n in nodes:
			#since igraph maps 0 to 1
			correct = int(n) -1
			sn = str(correct)
			if id2gene.has_key(sn):
				if source != id2gene[sn]:
					outfile.write("\t" + id2gene[sn])
				string_nodes.append(id2gene[sn])
		outfile.write("\n")
		
uniq_nodes = set(string_nodes)

for unodes in uniq_nodes:
	string_list.write(unodes + "\n")
	
igraph_file.close()
path_file.close()
outfile.close()
string_list.close()

	