#-*- coding: utf-8 -+-
#!/usr/bin/python

import sys
import math
import shutil, errno
import os
import shlex
import gzip
from pylab import *
from random import *
import subprocess
from numpy.linalg import norm

#all_target_ids_file:
#awk '/Human,/ {print}' all_target_ids_all.csv > all_target_ids_all_Human.txt -> only human 

if len(sys.argv)!= 5:
  sys.stderr.write("Usage: python parseDrugBank.py <all_target_ids_file> <drugbank_xml_file> <parsed_sprot.txt> <outfile>")
  sys.exit(-1)

target_file = open(sys.argv[1],'r')
drugbank = open(sys.argv[2],'r')
sprot = open(sys.argv[3],'r')
outfile = open(sys.argv[4],'w')

#key = uid, store corresponding gene symbol
uid2gene = {}

#read uniprot AC
for uline in sprot:
	if uline.find("##GENE") == -1:
		gene_symbol = uline.split("\t")[0]
		u_uid = uline.split("\t")[1]
		#if gene_symbol != "":
		uid2gene[u_uid] = gene_symbol


#key = P19113, store list of DB-entries:  DB00114; DB00117
gene2druglist = {}

#get uid - DB assignment
for lline in target_file:
	line = lline.strip()
	uid = line.split(",")[0]
	db_string = line.split("Human,")[1]
	db_list = []
	if db_string.find(";") != -1:
		db_list = db_string.split("; ")
	else:
		db_list.append(db_string)
	#print "-----DBs: ",db_list
	#find corresponding gene symbol
	if uid2gene.has_key(uid):
		gene = uid2gene[uid]
		if not gene2druglist.has_key(gene):
			gene2druglist[gene] = [] 
		for db in db_list:
			gene2druglist[gene].append(db)


db = ""
indication = ""
#key = DB number,e.g. DB00114, store corresponding indication
db2indication = {}

#get indication info from xml file
for xline in drugbank:
	if xline.find("<drugbank-id primary") != -1:
		db = (xline.split("</drugbank-id>")[0]).split(">")[1]
	if xline.find("<indication>") != -1:
		indication = (xline.split("<indication>")[1]).split("</indication>")[0]
		#NOTE sometimes these chars are at the end of an indication
		if xline.find("&#13;") != -1:
			indication = indication.split("&#13;")[0]
		if not db2indication.has_key(db):
			db2indication[db] = indication
		indication = ""
		db = ""
	#when no indication available: line only contains <indication/>
	elif xline.find("<indication/>") != -1:
		if not db2indication.has_key(db):
			db2indication[db] = "-"
		db = ""

		
		
#lookup drugbank indication info for available uids
for key in gene2druglist:
	outfile.write(key + "\t")
	written = False
	for nr in gene2druglist[key]:
		if db2indication.has_key(nr):
			#NOTE we write all available drug indications in this file
			outfile.write(db2indication[nr] + ";")
			written = True
	if not written :
			outfile.write("-")
	outfile.write("\n")
	
sprot.close()
target_file.close()
drugbank.close()
outfile.close()

