require(arules)
require(arulesViz)


#generate non-redundant association rules
generateAssociations <- function(input_matrix_file,outfile,minlength,maxlength,support,confidence)
{

	data = as.matrix(read.table(input_matrix_file,header=T,sep="\t"))
	tdata = t(data)
	print("data read, start apriori...")

	#apriori(data,parameter,appearance,control)
	rules = apriori(tdata,parameter=list(minlen=minlength,maxlen=maxlength,supp=support,conf=confidence,target="rules"))
	#rules = apriori(tdata,parameter=list(minlen=minlength,maxlen=maxlength,supp=support,conf=confidence),appearance=list(items=c("AM=1"),default="none"))

	print(length(rules))

	#remove redundant rules
	if(length(rules) > 1)
	{
		rules.sorted = sort(rules,by="lift")
		print("rules sorted...")
		subset.matrix = is.subset(rules.sorted,rules.sorted)
		subset.matrix[lower.tri(subset.matrix,diag=T)] = NA
		print("subset.matrix generated....")
		redundant = colSums(subset.matrix,na.rm=T) >= 1
		print("redundant done...")
		which(redundant)

		rules.pruned = rules.sorted[!redundant]
		print("write to file...")
		write(rules.pruned,outfile,quote=F,sep="\t")
	}
	else if(length(rules) == 1)
	{
		write(rules,outfile,quote=F,sep="\t")
	}
}
